/*
 * Copyright 2020 ETSI
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its contributors 
 *    may be used to endorse or promote products derived from this software without 
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package fr.emse.gitlab.saref.managers;

import java.util.ArrayList;

public class OopsManager {

	public static ArrayList<ArrayList<String>> getData(Object[] data) {
		ArrayList<String> getID = new ArrayList<String>();
		ArrayList<String> getName = new ArrayList<String>();
		ArrayList<String> getInfo = new ArrayList<String>();
		ArrayList<String> affectedElements = new ArrayList<String>();

		ArrayList<ArrayList<String>> elements = new ArrayList<ArrayList<String>>();
		elements.add(getID);
		elements.add(getName);
		elements.add(getInfo);
		elements.add(affectedElements);

		String affected = "";

		for (int i = 0; i < data.length; i++) {
			String data2 = data[i].toString().replaceAll("  ", "");


			if (data2.startsWith("<oops:hasCode")) {
				String[] data3 = data2.split("(<|>)");
				getID.add(data3[2]);
				elements.set(0, getID);
			} else if (data2.startsWith("<oops:hasName")) {
				String[] data3 = data2.split("(<|>)");
				getName.add(data3[2]);
				elements.set(1, getName);
			} else if (data2.startsWith("<oops:hasDescription")) {
				String[] data3 = data2.split("(<|>)");
				getInfo.add(data3[2]);
				elements.set(2, getInfo);
			}
			if (i>0 && i < data.length-1) {
				String prove = data[i - 1].toString().replaceAll("  ", "");
				String prove2 = data[i + 1].toString().replaceAll("  ", "");

				if (data2.startsWith("<oops:hasAffectedElement")) {
					if (!prove.startsWith("<oops:hasAffectedElement")) {
						String[] data3 = data2.split("(<|>)");
						affected += data3[2];
					}
					else if (!prove2.startsWith("<oops:hasAffectedElement")){
						String[] data3 = data2.split("(<|>)");
						affected += ", " + data3[2];
						affectedElements.add(affected);
						elements.set(3, affectedElements);
						affected = "";
					}
					else{
						String[] data3 = data2.split("(<|>)");
						affected += ", " + data3[2];
					}
				}

			}

		}

		return elements;
	}

	public static int counter(Object[] data) {
		int counter = 0;
		for (int i = 0; i < data.length; i++) {
			String data2 = data[i].toString().replaceAll("  ", "");
			if (data2.startsWith("<oops:hasCode")) {
				counter++;
			}
		}
		return counter;
	}

}
